package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.UtilsMapper;
import com.steerinfo.dil.service.IUtilsService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/26 14:42
 */

@Service(value = "utilsService")
public class UtilsServiceImpl implements IUtilsService {
    @Autowired
    private UtilsMapper utilsMapper;

    /**
     * 查询运输订单ID主键
     * @return
     */
    @Override
    public BigDecimal selectOrderMaxId() {
        return utilsMapper.selectOrderMaxId();
    }

    /**
     * 查询运输订单子表主键ID
     * @return
     */
    @Override
    public BigDecimal selectOrderMaterialMaxId() {
        return utilsMapper.selectOrderMaterialMaxId();
    }

    /**
     * 修改运力状态
     * @param map {必要参数：capacityId 运力ID  或者 capacityNumber 车牌号}
     * @param status 类型
     * @return
     */
    public int updateCapacityStatus(Map<String, Object> map, Integer status){
        map.put("capacityStatus", status);
        return  utilsMapper.updateCapacityByCarIdOrNum(map);
    }


    /**
     * 修改订单状态为结束
     * @param map {orderId 订单Id
     * @return
     */
    public int updateOrderStatus(Map<String, Object> map, Integer status){
        map.put("orderStatus", status);
        return utilsMapper.updateOrderStatusByOrderIdOrNum(map);
    }

    /**
     * 用于更新路段顺序号
     * @param map  orderId 运输订单号
     * @return
     */
    public int updateOrderLineSequence(Map<String, Object> map, Integer lineSequence){
        map.put("orderLineSequence", lineSequence);
        return utilsMapper.updateLineSeqByOrderIdOrNum(map);
    }

}
